/*****************************************************
CodeWizardAVR V2.05.0 Professional

Project : Clock
Version : 1.0
Date    : 01.10.2012
Author  : FI
Company :
Comments:

Chip type               : ATmega8
Program type            : Application
AVR Core Clock frequency: 7,372800 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega8.h>
#include <notas.h>
#include <clock.h>
#include <ds1307_twi.h>

// Declare your global variables here

unsigned char	alarm[10][2]; // 
//unsigned char	alarm_day[10] = {1,1,2,3,4,5,6,0,0,0};			//    .  (0 - .)
unsigned char	alarm_on[10];									//  
unsigned char	alarm_detect = 0;								//    
unsigned char	ring_en = 0;					 				//  
unsigned char	ring_push_btn = 1; 								//   
unsigned char	repeat;											//   

unsigned char	i, k, j = 0, depoison;
unsigned char	blink_delay;									//     
unsigned char	blink = 0xFE;									//      

unsigned char 	KEYS[10];                        				//   ( 4  6)
unsigned char 	key;	                        				//  
unsigned char	key_delay;                      				//  (   ) 

unsigned char	cursor = 0;										//  
unsigned char	shift[] = {6, 5, 4, 1, 2, 3, 7};				// 
unsigned char	mode = 0;										// 
unsigned int	mode_reset = 0;									//       
unsigned int	read_flag = 0;									//     DS1307
unsigned int	read_date = 1;									//    
unsigned char	ERROR;											//  
unsigned char 	ind[10] = {0x40, 0x20, 0x10, 0x02, 0x04, 0x08, 0x80, 0x80, 0x80, 0x80}; //  
unsigned char 	ind_temp, data[] = {0,0,0,0,0,0,1,4,7,0};	 	//   : ______1_2_3_4
//unsigned char 	sfd, dot=0, data_old[] = {0,0,0,0,0,0,1,4,7,0};		//  
unsigned char 	TIME[3], DATE[3];// DAY;							// , ,   

unsigned char 	BUF[]={0, 0, 0};								//   
unsigned char 	buf_set[7];										//   
unsigned char 	old;        				//

unsigned char 	settings[] = {00, 00, 00};						// . 
#define sounder	settings[0]/10									//  / 
#define effect	settings[0]%10									//   
#define date_show	settings[1]/10								//      
#define dots_state	settings[1]%10								//  
#define hour_beep	settings[2]/10								//  
#define melody_N	settings[2]%10								//  

//------------------------------------------------------------------------

signed char iocr=25; 	//   
char ms=0; 				// 

char fr[6]; 			//   
char tscr[6]; 			//  

char bright[]={1,1,1,1,1,1,1,1,1,1}; //      
//flash char psc[]={1,21,42,63,84,105,126,147,168,189,210,231,245,231,210,189,168,147,126,105,84,63,42,21,1}; //  ,    -   
flash char psc[]={1,21,42,64,87,111,136,162,189,217,246,246,246,246,246,217,189,162,136,111,87,64,42,21,1}; //  ,    -   
//                  20 21 22 23 24  25  26  27   28  29  30
void setscr (char a, char b, char c, char d);
//------------------------------------------------------------------------

//void OUT(unsigned char DIGIT);
void convert_data (unsigned char x[3]);
void _init(void);

void main(void)
{
// Declare your local variables here
// Port B initialization
PORTB=0x00;	DDRB=0x07;

// Port C initialization
PORTC=0x00;	DDRC=0x07;

// Port D initialization
PORTD=0x00;	DDRD=0xFE;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 7,200 kHz
// Mode: CTC top=OCR1A
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x10;
OCR1AL=0x5D;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 115,200 kHz
// Mode: Fast PWM top=0xFF
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x4C;
TCNT2=0x00;
OCR2=0x01;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0xC0;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC disabled
ADCSRA=0x00;

// TWI initialization
// Bit Rate: 10,400 kHz
TWBR=0x1D;
// Two Wire Bus Slave Address: 0x0D
// General Call Recognition: Off
TWAR=0x1A;
// Generate Acknowledge Pulse: On
// TWI Interrupt: Off
TWCR=0x44;
TWSR=0x00;

// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/1024k
#pragma optsize-
WDTCR=0x1E;
WDTCR=0x0E;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// DS1307 Real Time Clock initialization
// Square wave output on pin SQW/OUT: Off
// SQW/OUT pin state: 0
rtc_init(0,0,0);

_init();

#asm ("sei")
while (1){
      // Place your code here
	#asm("wdr")                                                             //   
	if (!mode)
	switch (dots_state){
    	case 0: for (i=6; i<10; i++) ind[i] = 0x00;
        		break;
        case 1: for (i=6; i<10; i++) ind[i] = 0x80;
        		break;
        case 2: for (i=6; i<10; i++)
        			if ((TIME[2] & 0x01)) ind[i] = 0x00;
                    else ind[i] = 0x80;
        		break;
    }

	if (read_date){                                                         //   
    	rtc_get_date(&DATE[0], &DATE[1], &DATE[2]);                         //  
        read_date=0;                                                        //  
    }
							/*----- ALARM -----*/
    switch (alarm_detect){
    	case 0:
//        	if ((alarm_day[j] == DAY)||(alarm_day[j] == 8)){				//     (  5 )
			if (alarm_on[j] == 1){                                          //    
                if ((alarm[j][0]==TIME[0]) && (alarm[j][1]==TIME[1])){		//     (:)
					alarm_detect = 1;                                       //     ( )
                    nota = mel[melody_N];
                    break;
                }
            }
            j++;
            if (j > 9) j = 0;                                               //    
            break;
        case 1:
            if (ring_push_btn){ring_en = 1; repeat = 1;} 					//    - / .
            else {ring_en = 0; repeat = 0;}
            if ((TIME[1]>alarm[j][1]) && (TIME[1]<(alarm[j][1]+5))) ring_en = 0;	// .   .  
            if ((alarm[j][0]==TIME[0]) && ((alarm[j][1]+5)==TIME[1]) && (repeat)){	// :    
                if (ring_push_btn) {ring_en = 1;} 							//    -  
                else {ring_en = 0; repeat = 0;}                             //  ,  
            }
            if (TIME[1] > (alarm[j][1]+5)){                               	// .   
            	ring_en = 0;
                ring_push_btn = 1;                                          //
                j = 0;
                alarm_detect = 0;                                           //  
            }
            break;
    }
//---------------------------------------------------------------------------------

                          /*---- RING ----*/
	if ((ring_en)&&(ring_push_btn)){        		//    
                    if (*nota==0xFF) nota = mel[melody_N];
                    if (next_nota == 1){                //     
                        f_nota = (*nota)&0x1F;        	//   ( )
                        d_nota = ((*nota)>>5)&0x07;   	//  
                        nota_time = delay[d_nota];   	// 
                        OCR1A = div[f_nota];            //      
						if (f_nota){
                        	if (sounder) TCCR1A = 0x40; else TCCR1A = 0xC0;
                        }
                        next_nota = 0;                  //    
                    }
                    if (nota_time==0){                  //    
                        TCCR1A = 0x00; //BUZZER=0;		// . 
                        next_nota = 1;                  //    
                        nota++;                         //  
                    }
    }
//---------------------------------------------------------------------------------

                          /*---- BUTTONS ----*/
	for (key=1; key<5; key++){										//  
//	    if (KEYS[key])
        switch(key){
                          /*------ MODE -----*/
            case 1:													//   (MODE)
            	if (BTN_MODE){										// 0 - ( )
                    key_reset; 			                			//   
					if ((++mode)>4) mode = 0;
                    cursor = 0;                         			//     
                    switch (mode){
			        	case 1: // 1 - . 
                        	for (i=0; i<3; i++){
	            		    	buf_set[i*2] = TIME[i]/10;    		//      
    	                        buf_set[i*2+1] = TIME[i]%10;}
                            break;
						case 2: // 2 - . 
				            rtc_get_date(&DATE[0], &DATE[1], &DATE[2]);
                            for (i=0; i<3; i++){
	            		    	buf_set[i*2] = DATE[i]/10;    		//  
	                            buf_set[i*2+1] = DATE[i]%10;}
                            break;
			            case 3: // 3 - . ()
				            for (i=0; i<2; i++){
	            		    	buf_set[i*2] = alarm[0][i]/10;		//   1
	                            buf_set[i*2+1] = alarm[0][i]%10;}
	                        buf_set[4] = 0; buf_set[5] = alarm_on[0]; // alarm_day[0];
                            break;
                        case 4: // 4 - 
				            for (i=0; i<3; i++){
	            		    	buf_set[i*2] = settings[i]/10;    	//  
	                            buf_set[i*2+1] = settings[i]%10;}
                            break;
                    }
			        for (i=0; i<3; i++)
           				BUF[i] = buf_set[i*2]*10+buf_set[i*2+1]; 	//     
	            }
                break;
						/*------- NEXT -------*/
    		case 2:                                     //  
            	if (BTN_NEXT == 1){
            		key_reset;
   	                if ((++cursor)>5) cursor = 0;
            	}
                break;
						/*----- SET / DATE -----*/
            case 3:                                     //  
	          	if (BTN_SET == 1){
            		key_reset;
					if (mode != 0){
                        ind[6] = 0x80;                 //   ->  ,
                        ind[7] = 0x80;                 //   "SAVE" 
                        ind[8] = 0x80;                 //   
                        ind[9] = 0x80;
                        switch (cursor){
                            case 0:	// () /
                                ++buf_set[cursor];
                                if ((mode == 2)&&(buf_set[cursor]>3)) buf_set[cursor]=0;
                                if ((mode != 2)&&(buf_set[cursor]>2)) buf_set[cursor]=0;
                                if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
                                break;
                            case 1:	// () /
                                ++buf_set[cursor];
                                if (buf_set[cursor]>9) buf_set[cursor]=0;
                                if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
                                break;
                            case 2:	// () /
                                ++buf_set[cursor];
                                if ((mode == 2)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
                                if ((mode != 2)&&(buf_set[cursor]>5)) buf_set[cursor]=0;
                                if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
                                break;
                            case 3:	// () /
                                ++buf_set[cursor];
                                if (buf_set[cursor]>9) buf_set[cursor]=0;
                                if ((mode == 4)&&(buf_set[cursor]>2)) buf_set[cursor]=0;
                                break;
                            case 4:	// () / 
                                ++buf_set[cursor];
                                if (((mode == 2)||(mode == 3))&&(buf_set[cursor]>9)) buf_set[cursor]=0;
                                if (mode == 1) buf_set[cursor]=0;
                                if (mode == 3){
                                    for (i=0; i<2; i++){
                                        buf_set[i*2]=alarm[buf_set[cursor]][i]/10;   //  
                                        buf_set[i*2+1]=alarm[buf_set[cursor]][i]%10;}
                                    buf_set[5]=alarm_on[buf_set[cursor]];
                                }
                                if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
                                break;
                            case 5:	// () / 
                                ++buf_set[cursor];
                                if ((mode == 2)&&(buf_set[cursor]>9)) buf_set[cursor]=0;
                                if (mode == 1) buf_set[cursor]=0;
                                if ((mode == 3)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
                                if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
                                break;
                        }
                        for (i=0; i<3; i++)
                            BUF[i]=buf_set[i*2]*10+buf_set[i*2+1];
                    }
                    else mode = 5;						//  
               	}
                break;
						/*----- SAVE / ALARM OFF -----*/
    		case 4:
            	if (BTN_SAVE){                      	//     !!!!!!!!!!!!!!!
            		key_reset;
                    if ((mode == 0)&&(ring_en)){
                    	ring_push_btn = 0; TCCR1A=0x00; BUZZER = 0;//  
                    }
                    if ((mode==1)||(mode==3)){
                    	if ((BUF[0]>24)||(BUF[1]>59)) {ERROR=1;}
                        else ERROR=0;
                    }
					if (mode==2){
                    	if ((BUF[0]>31)||(BUF[1]>12)) {ERROR=1;}
                        else ERROR=0;
                    }
                    if (!ERROR){
                        ind[6] = 0x00;                 //   ->  
                        ind[7] = 0x00;
                        ind[8] = 0x00;
                        ind[9] = 0x00;
                        if (mode==1) rtc_set_time(BUF[0],BUF[1],BUF[2]);
                        if (mode==2) rtc_set_date(BUF[0],BUF[1],BUF[2]);
	                    if (mode==3){
                        	for (i=0; i<2; i++){
                            	alarm[buf_set[4]][i]=BUF[i];
                            	EEP_ALARM[buf_set[4]][i]=BUF[i];
                            }
	                        alarm_on[buf_set[4]]=BUF[2]%10;
	                        EEP_alarm_on[buf_set[4]]=BUF[2]%10;
                        }
	                    if (mode==4){
                        	for (i=0; i<3; i++){
                            	settings[i]=BUF[i];
                            	EEP_SET[i]=BUF[i];
                            }
							nota = mel[melody_N];
                        }
                    }
               	}
                break;
        }
	}
//---------------------------------------------------------------------------------

							/*----- MODE -----*/
    switch (mode){
        case 0:                                                         //    ( )
        	old = TIME[2];                                              //    
			if (!read_flag){                                            //   
            	rtc_get_time(&TIME[0], &TIME[1], &TIME[2]);             //  
            }
            if ((old != TIME[2])){                                      //    
                setscr(TIME[0], TIME[1], TIME[2], effect);              //  
            	if ((TIME[0]+TIME[1]+TIME[2]) == 0){
                	read_date = 1;         								//    ( 00:00:00)     
                    if ((++depoison) > 9){                              //   10     
                    	depoison = 0;
						mode_reset = 54000;                             // ~1 .
                        mode = 6;
                    }
                    EEP_depoison = depoison;                            //
                }
                if (((TIME[1]+TIME[2]) == 0) && (depoison)){
                	if (date_show){        								//         
    	            	mode_reset = 4500;                              //  ~10 .
	                    mode = 5;
                    }
                    if ((hour_beep==1) && (ring_en==0)){                 //   
                    	key_reset;
                    }
                }
            }
            break;
        case 6:                                                         //   
        	if (!read_flag)
                for (k=0; k<6; k++){
                    if ((data[k]++)>9)
                        data[k] = 0;
                }
			break;
        case 5:                                                         //   
            convert_data(DATE);
            break;
		default: convert_data(BUF);                                     //       
	};

//--------------------------   ----------------------------------

    if ((mode>0)&&(mode<5)&&(blink_delay<100)) blink &= ~(1<<shift[cursor]); //    
    else blink = 0xFE;
//    blink_delay &= 0x00FF;

//---------------------------------------------------------------------------
}	//    while{1}
}

// Timer 2 overflow interrupt service routine
//   2                  115200  / 256 = 450 
interrupt [TIM2_OVF] void timer2_ovf_isr(void){

    static char i;
    //anod_1=0; anod_2=0; anod_3=0; anod_4=0; anod_5=0; anod_6=0; anod_7=0;
    PORTD &= 0x01;                             	//  

    read_flag++; read_flag &=0x3F;              //     

	if (iocr<24){                           	//  . < 24
        if ((++ms)==16){// ~32 mc               //  . = 16
            ms=0;               	           	// 
            iocr++;                 		 	//  .
            for (i=0; i<6; i++){               	//   
	            if ((fr[i]==1)||(iocr==0))   	//     . = 0
    	            bright[i]=psc[iocr];    	//  =   .
        	    else bright[i]=bright[6]; 		//   = 1
            	if (iocr==13)                 	//  . = 13 (  . psc[13])- 
                	data[i]=tscr[i]; 			//  
            }
    	}
	}

}

// Timer 2 output compare interrupt service routine
//   
interrupt [TIM2_COMP] void timer2_comp_isr(void){

    static char digit = 0;
    decoder_out(data[digit]);        					//     
    ind_temp = ind[digit] & blink;
	PORTD = ind_temp;			      					//   
/*
    switch (digit){ 									//   
        case 0: anod_1=1; break;
        case 1: anod_2=1; break;
        case 2: anod_3=1; break;
        case 3: anod_4=1; break;
        case 4: anod_5=1; break;
        case 5: anod_6=1; break;
        case 6: break; 									// -  
    }
*/
    if ((key_delay == 0)){
    	KEYS[digit] = BUTTON;							//     - 
		if (!ring_en) {TCCR1A = 0x00; BUZZER = 0;}
    }
	else (key_delay--);                      			// 
    if (key_delay==50){TCCR1A = 0x00; BUZZER=0;}		//          

    if ((++digit)>9) digit=0;                           //   
    OCR2=bright[digit];									//   =  .

    blink_delay++;
    if (nota_time) nota_time--;
	if (mode_reset == 0) mode = 0;
    else mode_reset--;
}

void setscr (char a, char b, char c, char d) 			//   
{
	static char i;
	if (d==1){                                          //  .  
		tscr[0]=a/10; tscr[1]=a%10; tscr[2]=b/10;
        tscr[3]=b%10; tscr[4]=c/10; tscr[5]=c%10;}		//    
	else {
 		data[0]=a/10; data[1]=a%10; data[2]=b/10;
        data[3]=b%10; data[4]=c/10; data[5]=c%10;} 		//    
	for (i=0; (i<6)&&(d==1); i++){                      //      
    	if (tscr[i]!=data[i]) {fr[i]=1;}                //      
        else fr[i]=0;
  	}
 //----------------------------
	if (d==1) iocr=-1;                                  //  .   . = -1
	else iocr=25;                                       //  . = 25
}


/*________________        ________________*/

void convert_data (unsigned char x[3]){
	for (i=0; i<3; i++){
	 	data[i*2] = /*x[i]>>4;*/x[i]/10;     			// 
	 	data[i*2+1] = /*x[i]&0x0F;*/x[i]%10;			// 
    }
}

/*_________________       ______________*/
/*
void OUT(unsigned char DIGIT)
{
    PORTC.2 = DECOD[DIGIT] & 0x01;
    PORTC.0 = DECOD[DIGIT] & 0x02;           //   . 
    PORTB.2 = DECOD[DIGIT] & 0x04;
    PORTC.1 = DECOD[DIGIT] & 0x08;
}
*/

/*___________________     EEPROM ____________________*/

void _init(void){
														//    EEPROM
    for (i=0; i<10; i++){
        for (j=0; j<2; j++){
            alarm[i][j] = EEP_ALARM[i][j];
        }
        alarm_on[i] = EEP_alarm_on[i];
//        alarm_day[i] = EEP_alarm_day[i];
    }
    for (i=0; i<3; i++){
		settings[i] = EEP_SET[i];
	}
	depoison = EEP_depoison;

}

