
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega8
;Program type             : Application
;Clock frequency          : 7,372800 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1119
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _nota=R4
	.DEF _f_nota=R7
	.DEF _d_nota=R6
	.DEF _next_nota=R9
	.DEF _nota_time=R10
	.DEF _alarm_detect=R8
	.DEF _ring_en=R13
	.DEF _ring_push_btn=R12

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_comp_isr
	RJMP _timer2_ovf_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_DECOD:
	.DB  0x3,0x2,0x7,0x4,0x1,0x9,0x8,0x0
	.DB  0x5,0x6,0x10
_delay:
	.DB  0x0,0x0,0xC0,0x3,0xE0,0x1,0xF0,0x0
	.DB  0x78,0x0,0x3C,0x0,0x1E,0x0,0xF,0x0
_div:
	.DB  0x0,0x0,0xA,0x37,0xF4,0x33,0x9,0x31
	.DB  0x48,0x2E,0xAF,0x2B,0x3C,0x29,0xEC,0x26
	.DB  0xBC,0x24,0xAC,0x22,0xBA,0x20,0xE4,0x1E
	.DB  0x28,0x1D,0x85,0x1B,0xFA,0x19,0x85,0x18
	.DB  0x24,0x17,0xD8,0x15,0x9E,0x14,0x76,0x13
	.DB  0x5E,0x12,0x56,0x11,0x5D,0x10,0x72,0xF
	.DB  0x94,0xE,0xC3,0xD,0xFD,0xC,0x42,0xC
	.DB  0x92,0xB,0xEC,0xA,0x4F,0xA,0xBB,0x9
	.DB  0x2F,0x9,0xAB,0x8,0x2F,0x8,0xB9,0x7
	.DB  0x4A,0x7
_mel1:
	.DB  0x8A,0x85,0x8A,0x85,0x8A,0x89,0x69,0x89
	.DB  0x85,0x89,0x85,0x89,0x8A,0x6A,0x8A,0x85
	.DB  0x8A,0x85,0x8A,0x89,0x69,0x89,0x85,0x89
	.DB  0x85,0x89,0x6A,0x80,0x8A,0x8C,0xAC,0xAC
	.DB  0x8C,0x8C,0x8D,0xAD,0xAD,0x8D,0x8D,0x8D
	.DB  0x8C,0x8A,0x89,0x8A,0x6A,0x8A,0x8C,0xAC
	.DB  0xAC,0x8C,0x8C,0x8D,0xAD,0xAD,0x8D,0x8D
	.DB  0x8D,0x8C,0x8A,0x89,0x8A,0x4A,0xFF
_mel0:
	.DB  0xB6,0xA0,0xB6,0xA0,0xB6,0x40,0xFF
_psc:
	.DB  0x1,0x15,0x2A,0x40,0x57,0x6F,0x88,0xA2
	.DB  0xBD,0xD9,0xF6,0xF6,0xF6,0xF6,0xF6,0xD9
	.DB  0xBD,0xA2,0x88,0x6F,0x57,0x40,0x2A,0x15
	.DB  0x1

_0x3:
	.DB  LOW(_mel0*2),HIGH(_mel0*2),LOW(_mel1*2),HIGH(_mel1*2)
_0x11:
	.DB  0xFE
_0x12:
	.DB  0x6,0x5,0x4,0x1,0x2,0x3,0x7
_0x13:
	.DB  0x1
_0x14:
	.DB  0x40,0x20,0x10,0x2,0x4,0x8,0x80,0x80
	.DB  0x80,0x80
_0x15:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x4
	.DB  0x7
_0x16:
	.DB  0x19
_0x17:
	.DB  0x1,0x1,0x1,0x1,0x1,0x1,0x1,0x1
	.DB  0x1,0x1
_0x13D:
	.DB  0x0,0x1,0x0,0x0,0x1,0x0

__GLOBAL_INI_TBL:
	.DW  0x04
	.DW  _mel
	.DW  _0x3*2

	.DW  0x01
	.DW  _blink
	.DW  _0x11*2

	.DW  0x07
	.DW  _shift
	.DW  _0x12*2

	.DW  0x01
	.DW  _read_date
	.DW  _0x13*2

	.DW  0x0A
	.DW  _ind
	.DW  _0x14*2

	.DW  0x09
	.DW  _data
	.DW  _0x15*2

	.DW  0x01
	.DW  _iocr
	.DW  _0x16*2

	.DW  0x0A
	.DW  _bright
	.DW  _0x17*2

	.DW  0x06
	.DW  0x08
	.DW  _0x13D*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/*****************************************************
;CodeWizardAVR V2.05.0 Professional
;
;Project : Clock
;Version : 1.0
;Date    : 01.10.2012
;Author  : FI
;Company :
;Comments:
;
;Chip type               : ATmega8
;Program type            : Application
;AVR Core Clock frequency: 7,372800 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <notas.h>
;#include <clock.h>

	.DSEG
;#include <ds1307_twi.h>

	.CSEG
_twi_start:
	LDI  R30,LOW(228)
	OUT  0x36,R30
_0x4:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0x4
	RET
_twi_stop:
	LDI  R30,LOW(148)
	OUT  0x36,R30
	RET
_twi_write:
;	_data -> Y+0
	LD   R30,Y
	OUT  0x3,R30
	LDI  R30,LOW(132)
	OUT  0x36,R30
_0x7:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0x7
	ADIW R28,1
	RET
_twi_read:
	ST   -Y,R17
;	_ack -> Y+1
;	_data -> R17
	LDD  R26,Y+1
	CPI  R26,LOW(0x1)
	BRNE _0xA
	LDI  R30,LOW(196)
	RJMP _0x132
_0xA:
	LDI  R30,LOW(132)
_0x132:
	OUT  0x36,R30
_0xC:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	BREQ _0xC
	IN   R17,3
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x2020001
_rtc_init:
;	rs -> Y+2
;	sqwe -> Y+1
;	out -> Y+0
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0xF
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0xF:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x10
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x10:
	RCALL SUBOPT_0x0
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x1
	LDD  R30,Y+2
	RJMP _0x2020004
_rtc_set_time:
;	hour -> Y+2
;	min -> Y+1
;	sec -> Y+0
	RCALL SUBOPT_0x0
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1
	LD   R30,Y
	RCALL SUBOPT_0x2
	LDD  R30,Y+1
	RCALL SUBOPT_0x2
	LDD  R30,Y+2
	RJMP _0x2020003
_rtc_set_date:
;	date -> Y+2
;	month -> Y+1
;	year -> Y+0
	RCALL SUBOPT_0x0
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x1
	LDD  R30,Y+2
	RCALL SUBOPT_0x2
	LDD  R30,Y+1
	RCALL SUBOPT_0x2
	LD   R30,Y
_0x2020003:
	ST   -Y,R30
	RCALL _bin2bcd
_0x2020004:
	ST   -Y,R30
	RCALL _twi_write
	RCALL _twi_stop
	ADIW R28,3
	RET
_rtc_get_time:
;	*hour -> Y+4
;	*min -> Y+2
;	*sec -> Y+0
	RCALL SUBOPT_0x0
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x1
	RCALL _twi_start
	LDI  R30,LOW(209)
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x4
	ST   X,R30
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x5
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RJMP _0x2020002
_rtc_get_date:
;	*date -> Y+4
;	*month -> Y+2
;	*year -> Y+0
	RCALL SUBOPT_0x0
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x1
	RCALL _twi_start
	LDI  R30,LOW(209)
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x3
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
	RCALL SUBOPT_0x3
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x4
_0x2020002:
	ST   X,R30
	RCALL _twi_stop
	ADIW R28,6
	RET
;	*day -> Y+0
;	address -> Y+1
;	data -> R17
;	address -> Y+1
;	data -> Y+0
;
;// Declare your global variables here
;
;unsigned char	alarm[10][2]; // 
;//unsigned char	alarm_day[10] = {1,1,2,3,4,5,6,0,0,0};			//    .  (0 - .)
;unsigned char	alarm_on[10];									//  
;unsigned char	alarm_detect = 0;								//    
;unsigned char	ring_en = 0;					 				//  
;unsigned char	ring_push_btn = 1; 								//   
;unsigned char	repeat;											//   
;
;unsigned char	i, k, j = 0, depoison;
;unsigned char	blink_delay;									//     
;unsigned char	blink = 0xFE;									//      

	.DSEG
;
;unsigned char 	KEYS[10];                        				//   ( 4  6)
;unsigned char 	key;	                        				//  
;unsigned char	key_delay;                      				//  (   ) 
;
;unsigned char	cursor = 0;										//  
;unsigned char	shift[] = {6, 5, 4, 1, 2, 3, 7};				// 
;unsigned char	mode = 0;										// 
;unsigned int	mode_reset = 0;									//       
;unsigned int	read_flag = 0;									//     DS1307
;unsigned int	read_date = 1;									//    
;unsigned char	ERROR;											//  
;unsigned char 	ind[10] = {0x40, 0x20, 0x10, 0x02, 0x04, 0x08, 0x80, 0x80, 0x80, 0x80}; //  
;unsigned char 	ind_temp, data[] = {0,0,0,0,0,0,1,4,7,0};	 	//   : ______1_2_3_4
;//unsigned char 	sfd, dot=0, data_old[] = {0,0,0,0,0,0,1,4,7,0};		//  
;unsigned char 	TIME[3], DATE[3];// DAY;							// , ,   
;
;unsigned char 	BUF[]={0, 0, 0};								//   
;unsigned char 	buf_set[7];										//   
;unsigned char 	old;        				//
;
;unsigned char 	settings[] = {00, 00, 00};						// . 
;#define sounder	settings[0]/10									//  / 
;#define effect	settings[0]%10									//   
;#define date_show	settings[1]/10								//      
;#define dots_state	settings[1]%10								//  
;#define hour_beep	settings[2]/10								//  
;#define melody_N	settings[2]%10								//  
;
;//------------------------------------------------------------------------
;
;signed char iocr=25; 	//   
;char ms=0; 				// 
;
;char fr[6]; 			//   
;char tscr[6]; 			//  
;
;char bright[]={1,1,1,1,1,1,1,1,1,1}; //      
;//flash char psc[]={1,21,42,63,84,105,126,147,168,189,210,231,245,231,210,189,168,147,126,105,84,63,42,21,1}; //  ,    -   
;flash char psc[]={1,21,42,64,87,111,136,162,189,217,246,246,246,246,246,217,189,162,136,111,87,64,42,21,1}; //  ,    -   
;//                  20 21 22 23 24  25  26  27   28  29  30
;void setscr (char a, char b, char c, char d);
;//------------------------------------------------------------------------
;
;//void OUT(unsigned char DIGIT);
;void convert_data (unsigned char x[3]);
;void _init(void);
;
;void main(void)
; 0000 0056 {

	.CSEG
_main:
; 0000 0057 // Declare your local variables here
; 0000 0058 // Port B initialization
; 0000 0059 PORTB=0x00;	DDRB=0x07;
	LDI  R30,LOW(0)
	OUT  0x18,R30
	LDI  R30,LOW(7)
	OUT  0x17,R30
; 0000 005A 
; 0000 005B // Port C initialization
; 0000 005C PORTC=0x00;	DDRC=0x07;
	LDI  R30,LOW(0)
	OUT  0x15,R30
	LDI  R30,LOW(7)
	OUT  0x14,R30
; 0000 005D 
; 0000 005E // Port D initialization
; 0000 005F PORTD=0x00;	DDRD=0xFE;
	LDI  R30,LOW(0)
	OUT  0x12,R30
	LDI  R30,LOW(254)
	OUT  0x11,R30
; 0000 0060 
; 0000 0061 // Timer/Counter 1 initialization
; 0000 0062 // Clock source: System Clock
; 0000 0063 // Clock value: 7,200 kHz
; 0000 0064 // Mode: CTC top=OCR1A
; 0000 0065 // OC1A output: Discon.
; 0000 0066 // OC1B output: Discon.
; 0000 0067 // Noise Canceler: Off
; 0000 0068 // Input Capture on Falling Edge
; 0000 0069 // Timer1 Overflow Interrupt: Off
; 0000 006A // Input Capture Interrupt: Off
; 0000 006B // Compare A Match Interrupt: Off
; 0000 006C // Compare B Match Interrupt: Off
; 0000 006D TCCR1A=0x00;
	RCALL SUBOPT_0x6
; 0000 006E TCCR1B=0x09;
	LDI  R30,LOW(9)
	OUT  0x2E,R30
; 0000 006F TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 0070 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0071 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0072 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0073 OCR1AH=0x10;
	LDI  R30,LOW(16)
	OUT  0x2B,R30
; 0000 0074 OCR1AL=0x5D;
	LDI  R30,LOW(93)
	OUT  0x2A,R30
; 0000 0075 OCR1BH=0x00;
	LDI  R30,LOW(0)
	OUT  0x29,R30
; 0000 0076 OCR1BL=0x00;
	OUT  0x28,R30
; 0000 0077 
; 0000 0078 // Timer/Counter 2 initialization
; 0000 0079 // Clock source: System Clock
; 0000 007A // Clock value: 115,200 kHz
; 0000 007B // Mode: Fast PWM top=0xFF
; 0000 007C // OC2 output: Disconnected
; 0000 007D ASSR=0x00;
	OUT  0x22,R30
; 0000 007E TCCR2=0x4C;
	LDI  R30,LOW(76)
	OUT  0x25,R30
; 0000 007F TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 0080 OCR2=0x01;
	LDI  R30,LOW(1)
	OUT  0x23,R30
; 0000 0081 
; 0000 0082 // External Interrupt(s) initialization
; 0000 0083 // INT0: Off
; 0000 0084 // INT1: Off
; 0000 0085 MCUCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x35,R30
; 0000 0086 
; 0000 0087 // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 0088 TIMSK=0xC0;
	LDI  R30,LOW(192)
	OUT  0x39,R30
; 0000 0089 
; 0000 008A // Analog Comparator initialization
; 0000 008B // Analog Comparator: Off
; 0000 008C // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 008D ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
; 0000 008E SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 008F 
; 0000 0090 // ADC initialization
; 0000 0091 // ADC disabled
; 0000 0092 ADCSRA=0x00;
	OUT  0x6,R30
; 0000 0093 
; 0000 0094 // TWI initialization
; 0000 0095 // Bit Rate: 10,400 kHz
; 0000 0096 TWBR=0x1D;
	LDI  R30,LOW(29)
	OUT  0x0,R30
; 0000 0097 // Two Wire Bus Slave Address: 0x0D
; 0000 0098 // General Call Recognition: Off
; 0000 0099 TWAR=0x1A;
	LDI  R30,LOW(26)
	OUT  0x2,R30
; 0000 009A // Generate Acknowledge Pulse: On
; 0000 009B // TWI Interrupt: Off
; 0000 009C TWCR=0x44;
	LDI  R30,LOW(68)
	OUT  0x36,R30
; 0000 009D TWSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x1,R30
; 0000 009E 
; 0000 009F // Watchdog Timer initialization
; 0000 00A0 // Watchdog Timer Prescaler: OSC/1024k
; 0000 00A1 #pragma optsize-
; 0000 00A2 WDTCR=0x1E;
	LDI  R30,LOW(30)
	OUT  0x21,R30
; 0000 00A3 WDTCR=0x0E;
	LDI  R30,LOW(14)
	OUT  0x21,R30
; 0000 00A4 #ifdef _OPTIMIZE_SIZE_
; 0000 00A5 #pragma optsize+
; 0000 00A6 #endif
; 0000 00A7 
; 0000 00A8 // DS1307 Real Time Clock initialization
; 0000 00A9 // Square wave output on pin SQW/OUT: Off
; 0000 00AA // SQW/OUT pin state: 0
; 0000 00AB rtc_init(0,0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	ST   -Y,R30
	RCALL _rtc_init
; 0000 00AC 
; 0000 00AD _init();
	RCALL __init
; 0000 00AE 
; 0000 00AF #asm ("sei")
	sei
; 0000 00B0 while (1){
_0x18:
; 0000 00B1       // Place your code here
; 0000 00B2 	#asm("wdr")                                                             //   
	wdr
; 0000 00B3 	if (!mode)
	RCALL SUBOPT_0x7
	CPI  R30,0
	BRNE _0x1B
; 0000 00B4 	switch (dots_state){
	RCALL SUBOPT_0x8
	RCALL __MODW21
; 0000 00B5     	case 0: for (i=6; i<10; i++) ind[i] = 0x00;
	SBIW R30,0
	BRNE _0x1F
	RCALL SUBOPT_0x9
_0x21:
	RCALL SUBOPT_0xA
	BRSH _0x22
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0xE
	RJMP _0x21
_0x22:
; 0000 00B6 break;
	RJMP _0x1E
; 0000 00B7         case 1: for (i=6; i<10; i++) ind[i] = 0x80;
_0x1F:
	RCALL SUBOPT_0xF
	BRNE _0x23
	RCALL SUBOPT_0x9
_0x25:
	RCALL SUBOPT_0xA
	BRSH _0x26
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
	LDI  R26,LOW(128)
	STD  Z+0,R26
	RCALL SUBOPT_0xE
	RJMP _0x25
_0x26:
; 0000 00B8 break;
	RJMP _0x1E
; 0000 00B9         case 2: for (i=6; i<10; i++)
_0x23:
	RCALL SUBOPT_0x10
	BRNE _0x1E
	RCALL SUBOPT_0x9
_0x29:
	RCALL SUBOPT_0xA
	BRSH _0x2A
; 0000 00BA         			if ((TIME[2] & 0x01)) ind[i] = 0x00;
	RCALL SUBOPT_0x11
	ANDI R30,LOW(0x1)
	BREQ _0x2B
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
	LDI  R26,LOW(0)
	RJMP _0x133
; 0000 00BB                     else ind[i] = 0x80;
_0x2B:
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
	LDI  R26,LOW(128)
_0x133:
	STD  Z+0,R26
; 0000 00BC         		break;
	RCALL SUBOPT_0xE
	RJMP _0x29
_0x2A:
; 0000 00BD     }
_0x1E:
; 0000 00BE 
; 0000 00BF 	if (read_date){                                                         //   
_0x1B:
	LDS  R30,_read_date
	LDS  R31,_read_date+1
	SBIW R30,0
	BREQ _0x2D
; 0000 00C0     	rtc_get_date(&DATE[0], &DATE[1], &DATE[2]);                         //  
	RCALL SUBOPT_0x12
; 0000 00C1         read_date=0;                                                        //  
	STS  _read_date,R30
	STS  _read_date+1,R30
; 0000 00C2     }
; 0000 00C3 							/*----- ALARM -----*/
; 0000 00C4     switch (alarm_detect){
_0x2D:
	MOV  R30,R8
	RCALL SUBOPT_0x13
; 0000 00C5     	case 0:
	SBIW R30,0
	BRNE _0x31
; 0000 00C6 //        	if ((alarm_day[j] == DAY)||(alarm_day[j] == 8)){				//     (  5 )
; 0000 00C7 			if (alarm_on[j] == 1){                                          //    
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x15
	LD   R26,Z
	CPI  R26,LOW(0x1)
	BRNE _0x32
; 0000 00C8                 if ((alarm[j][0]==TIME[0]) && (alarm[j][1]==TIME[1])){		//     (:)
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	BRNE _0x34
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x19
	LDD  R26,Z+1
	RCALL SUBOPT_0x1A
	CP   R30,R26
	BREQ _0x35
_0x34:
	RJMP _0x33
_0x35:
; 0000 00C9 					alarm_detect = 1;                                       //     ( )
	LDI  R30,LOW(1)
	MOV  R8,R30
; 0000 00CA                     nota = mel[melody_N];
	RCALL SUBOPT_0x1B
; 0000 00CB                     break;
	RJMP _0x30
; 0000 00CC                 }
; 0000 00CD             }
_0x33:
; 0000 00CE             j++;
_0x32:
	RCALL SUBOPT_0x1C
; 0000 00CF             if (j > 9) j = 0;                                               //    
	LDS  R26,_j
	CPI  R26,LOW(0xA)
	BRLO _0x36
	RCALL SUBOPT_0x1D
; 0000 00D0             break;
_0x36:
	RJMP _0x30
; 0000 00D1         case 1:
_0x31:
	RCALL SUBOPT_0xF
	BREQ PC+2
	RJMP _0x30
; 0000 00D2             if (ring_push_btn){ring_en = 1; repeat = 1;} 					//    - / .
	TST  R12
	BREQ _0x38
	LDI  R30,LOW(1)
	MOV  R13,R30
	RJMP _0x134
; 0000 00D3             else {ring_en = 0; repeat = 0;}
_0x38:
	CLR  R13
	LDI  R30,LOW(0)
_0x134:
	STS  _repeat,R30
; 0000 00D4             if ((TIME[1]>alarm[j][1]) && (TIME[1]<(alarm[j][1]+5))) ring_en = 0;	// .   .  
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x19
	MOVW R0,R30
	LDD  R30,Z+1
	RCALL SUBOPT_0x1E
	CP   R30,R26
	BRSH _0x3B
	MOVW R30,R0
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x20
	CP   R26,R30
	CPC  R27,R31
	BRLT _0x3C
_0x3B:
	RJMP _0x3A
_0x3C:
	CLR  R13
; 0000 00D5             if ((alarm[j][0]==TIME[0]) && ((alarm[j][1]+5)==TIME[1]) && (repeat)){	// :    
_0x3A:
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x18
	BRNE _0x3E
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1F
	MOVW R26,R30
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x13
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x3E
	LDS  R30,_repeat
	CPI  R30,0
	BRNE _0x3F
_0x3E:
	RJMP _0x3D
_0x3F:
; 0000 00D6                 if (ring_push_btn) {ring_en = 1;} 							//    -  
	TST  R12
	BREQ _0x40
	LDI  R30,LOW(1)
	MOV  R13,R30
; 0000 00D7                 else {ring_en = 0; repeat = 0;}                             //  ,  
	RJMP _0x41
_0x40:
	CLR  R13
	LDI  R30,LOW(0)
	STS  _repeat,R30
_0x41:
; 0000 00D8             }
; 0000 00D9             if (TIME[1] > (alarm[j][1]+5)){                               	// .   
_0x3D:
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x20
	CP   R30,R26
	CPC  R31,R27
	BRGE _0x42
; 0000 00DA             	ring_en = 0;
	CLR  R13
; 0000 00DB                 ring_push_btn = 1;                                          //
	LDI  R30,LOW(1)
	MOV  R12,R30
; 0000 00DC                 j = 0;
	RCALL SUBOPT_0x1D
; 0000 00DD                 alarm_detect = 0;                                           //  
	CLR  R8
; 0000 00DE             }
; 0000 00DF             break;
_0x42:
; 0000 00E0     }
_0x30:
; 0000 00E1 //---------------------------------------------------------------------------------
; 0000 00E2 
; 0000 00E3                           /*---- RING ----*/
; 0000 00E4 	if ((ring_en)&&(ring_push_btn)){        		//    
	TST  R13
	BREQ _0x44
	TST  R12
	BRNE _0x45
_0x44:
	RJMP _0x43
_0x45:
; 0000 00E5                     if (*nota==0xFF) nota = mel[melody_N];
	MOVW R30,R4
	LPM  R26,Z
	CPI  R26,LOW(0xFF)
	BRNE _0x46
	RCALL SUBOPT_0x1B
; 0000 00E6                     if (next_nota == 1){                //     
_0x46:
	LDI  R30,LOW(1)
	CP   R30,R9
	BRNE _0x47
; 0000 00E7                         f_nota = (*nota)&0x1F;        	//   ( )
	MOVW R30,R4
	LPM  R30,Z
	ANDI R30,LOW(0x1F)
	MOV  R7,R30
; 0000 00E8                         d_nota = ((*nota)>>5)&0x07;   	//  
	MOVW R30,R4
	LPM  R26,Z
	RCALL SUBOPT_0x20
	LDI  R30,LOW(5)
	RCALL __ASRW12
	ANDI R30,LOW(0x7)
	MOV  R6,R30
; 0000 00E9                         nota_time = delay[d_nota];   	// 
	MOV  R30,R6
	LDI  R26,LOW(_delay*2)
	LDI  R27,HIGH(_delay*2)
	RCALL SUBOPT_0x21
	MOVW R10,R30
; 0000 00EA                         OCR1A = div[f_nota];            //      
	MOV  R30,R7
	LDI  R26,LOW(_div*2)
	LDI  R27,HIGH(_div*2)
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x22
; 0000 00EB 						if (f_nota){
	TST  R7
	BREQ _0x48
; 0000 00EC                         	if (sounder) TCCR1A = 0x40; else TCCR1A = 0xC0;
	RCALL SUBOPT_0x23
	BREQ _0x49
	LDI  R30,LOW(64)
	RJMP _0x135
_0x49:
	LDI  R30,LOW(192)
_0x135:
	OUT  0x2F,R30
; 0000 00ED                         }
; 0000 00EE                         next_nota = 0;                  //    
_0x48:
	CLR  R9
; 0000 00EF                     }
; 0000 00F0                     if (nota_time==0){                  //    
_0x47:
	MOV  R0,R10
	OR   R0,R11
	BRNE _0x4B
; 0000 00F1                         TCCR1A = 0x00; //BUZZER=0;		// . 
	RCALL SUBOPT_0x6
; 0000 00F2                         next_nota = 1;                  //    
	LDI  R30,LOW(1)
	MOV  R9,R30
; 0000 00F3                         nota++;                         //  
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
; 0000 00F4                     }
; 0000 00F5     }
_0x4B:
; 0000 00F6 //---------------------------------------------------------------------------------
; 0000 00F7 
; 0000 00F8                           /*---- BUTTONS ----*/
; 0000 00F9 	for (key=1; key<5; key++){										//  
_0x43:
	LDI  R30,LOW(1)
	STS  _key,R30
_0x4D:
	LDS  R26,_key
	CPI  R26,LOW(0x5)
	BRLO PC+2
	RJMP _0x4E
; 0000 00FA //	    if (KEYS[key])
; 0000 00FB         switch(key){
	RCALL SUBOPT_0x24
; 0000 00FC                           /*------ MODE -----*/
; 0000 00FD             case 1:													//   (MODE)
	RCALL SUBOPT_0xF
	BREQ PC+2
	RJMP _0x52
; 0000 00FE             	if (BTN_MODE){										// 0 - ( )
	__GETB1MN _KEYS,1
	CPI  R30,0
	BRNE PC+2
	RJMP _0x53
; 0000 00FF                     key_reset; 			                			//   
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	BREQ _0x54
	RCALL SUBOPT_0x27
	RJMP _0x55
_0x54:
	SBI  0x18,1
; 0000 0100 					if ((++mode)>4) mode = 0;
_0x55:
	RCALL SUBOPT_0x28
	SUBI R26,-LOW(1)
	STS  _mode,R26
	CPI  R26,LOW(0x5)
	BRLO _0x58
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x29
; 0000 0101                     cursor = 0;                         			//     
_0x58:
	LDI  R30,LOW(0)
	STS  _cursor,R30
; 0000 0102                     switch (mode){
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x13
; 0000 0103 			        	case 1: // 1 - . 
	RCALL SUBOPT_0xF
	BRNE _0x5C
; 0000 0104                         	for (i=0; i<3; i++){
	RCALL SUBOPT_0x2A
_0x5E:
	RCALL SUBOPT_0x2B
	CPI  R26,LOW(0x3)
	BRSH _0x5F
; 0000 0105 	            		    	buf_set[i*2] = TIME[i]/10;    		//      
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x2F
; 0000 0106     	                        buf_set[i*2+1] = TIME[i]%10;}
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x2E
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xE
	RJMP _0x5E
_0x5F:
; 0000 0107                             break;
	RJMP _0x5B
; 0000 0108 						case 2: // 2 - . 
_0x5C:
	RCALL SUBOPT_0x10
	BRNE _0x60
; 0000 0109 				            rtc_get_date(&DATE[0], &DATE[1], &DATE[2]);
	RCALL SUBOPT_0x12
; 0000 010A                             for (i=0; i<3; i++){
	STS  _i,R30
_0x62:
	RCALL SUBOPT_0x32
	BRSH _0x63
; 0000 010B 	            		    	buf_set[i*2] = DATE[i]/10;    		//  
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x2F
; 0000 010C 	                            buf_set[i*2+1] = DATE[i]%10;}
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x33
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xE
	RJMP _0x62
_0x63:
; 0000 010D                             break;
	RJMP _0x5B
; 0000 010E 			            case 3: // 3 - . ()
_0x60:
	RCALL SUBOPT_0x34
	BRNE _0x64
; 0000 010F 				            for (i=0; i<2; i++){
	RCALL SUBOPT_0x2A
_0x66:
	RCALL SUBOPT_0x2B
	CPI  R26,LOW(0x2)
	BRSH _0x67
; 0000 0110 	            		    	buf_set[i*2] = alarm[0][i]/10;		//   1
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x2F
; 0000 0111 	                            buf_set[i*2+1] = alarm[0][i]%10;}
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xE
	RJMP _0x66
_0x67:
; 0000 0112 	                        buf_set[4] = 0; buf_set[5] = alarm_on[0]; // alarm_day[0];
	LDI  R30,LOW(0)
	__PUTB1MN _buf_set,4
	LDS  R30,_alarm_on
	__PUTB1MN _buf_set,5
; 0000 0113                             break;
	RJMP _0x5B
; 0000 0114                         case 4: // 4 - 
_0x64:
	RCALL SUBOPT_0x36
	BRNE _0x5B
; 0000 0115 				            for (i=0; i<3; i++){
	RCALL SUBOPT_0x2A
_0x6A:
	RCALL SUBOPT_0x32
	BRSH _0x6B
; 0000 0116 	            		    	buf_set[i*2] = settings[i]/10;    	//  
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x2F
; 0000 0117 	                            buf_set[i*2+1] = settings[i]%10;}
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x37
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0xE
	RJMP _0x6A
_0x6B:
; 0000 0118                             break;
; 0000 0119                     }
_0x5B:
; 0000 011A 			        for (i=0; i<3; i++)
	RCALL SUBOPT_0x2A
_0x6D:
	RCALL SUBOPT_0x32
	BRSH _0x6E
; 0000 011B            				BUF[i] = buf_set[i*2]*10+buf_set[i*2+1]; 	//     
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x3B
	__ADDW1MN _buf_set,1
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0xE
	RJMP _0x6D
_0x6E:
; 0000 011C }
; 0000 011D                 break;
_0x53:
	RJMP _0x51
; 0000 011E 						/*------- NEXT -------*/
; 0000 011F     		case 2:                                     //  
_0x52:
	RCALL SUBOPT_0x10
	BRNE _0x6F
; 0000 0120             	if (BTN_NEXT == 1){
	__GETB2MN _KEYS,2
	CPI  R26,LOW(0x1)
	BRNE _0x70
; 0000 0121             		key_reset;
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	BREQ _0x71
	RCALL SUBOPT_0x27
	RJMP _0x72
_0x71:
	SBI  0x18,1
; 0000 0122    	                if ((++cursor)>5) cursor = 0;
_0x72:
	RCALL SUBOPT_0x3D
	SUBI R26,-LOW(1)
	STS  _cursor,R26
	CPI  R26,LOW(0x6)
	BRLO _0x75
	LDI  R30,LOW(0)
	STS  _cursor,R30
; 0000 0123             	}
_0x75:
; 0000 0124                 break;
_0x70:
	RJMP _0x51
; 0000 0125 						/*----- SET / DATE -----*/
; 0000 0126             case 3:                                     //  
_0x6F:
	RCALL SUBOPT_0x34
	BREQ PC+2
	RJMP _0x76
; 0000 0127 	          	if (BTN_SET == 1){
	__GETB2MN _KEYS,3
	CPI  R26,LOW(0x1)
	BREQ PC+2
	RJMP _0x77
; 0000 0128             		key_reset;
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	BREQ _0x78
	RCALL SUBOPT_0x27
	RJMP _0x79
_0x78:
	SBI  0x18,1
; 0000 0129 					if (mode != 0){
_0x79:
	RCALL SUBOPT_0x7
	CPI  R30,0
	BRNE PC+2
	RJMP _0x7C
; 0000 012A                         ind[6] = 0x80;                 //   ->  ,
	LDI  R30,LOW(128)
	__PUTB1MN _ind,6
; 0000 012B                         ind[7] = 0x80;                 //   "SAVE" 
	__PUTB1MN _ind,7
; 0000 012C                         ind[8] = 0x80;                 //   
	__PUTB1MN _ind,8
; 0000 012D                         ind[9] = 0x80;
	__PUTB1MN _ind,9
; 0000 012E                         switch (cursor){
	RCALL SUBOPT_0x3E
; 0000 012F                             case 0:	// () /
	SBIW R30,0
	BRNE _0x80
; 0000 0130                                 ++buf_set[cursor];
	RCALL SUBOPT_0x3F
; 0000 0131                                 if ((mode == 2)&&(buf_set[cursor]>3)) buf_set[cursor]=0;
	RCALL SUBOPT_0x40
	BRNE _0x82
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x4)
	BRSH _0x83
_0x82:
	RJMP _0x81
_0x83:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0132                                 if ((mode != 2)&&(buf_set[cursor]>2)) buf_set[cursor]=0;
_0x81:
	RCALL SUBOPT_0x40
	BREQ _0x85
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x3)
	BRSH _0x86
_0x85:
	RJMP _0x84
_0x86:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0133                                 if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
_0x84:
	RCALL SUBOPT_0x43
	BRNE _0x88
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x2)
	BRSH _0x89
_0x88:
	RJMP _0x87
_0x89:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0134                                 break;
_0x87:
	RJMP _0x7F
; 0000 0135                             case 1:	// () /
_0x80:
	RCALL SUBOPT_0xF
	BRNE _0x8A
; 0000 0136                                 ++buf_set[cursor];
	RCALL SUBOPT_0x3F
; 0000 0137                                 if (buf_set[cursor]>9) buf_set[cursor]=0;
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0xA)
	BRLO _0x8B
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0138                                 if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
_0x8B:
	RCALL SUBOPT_0x43
	BRNE _0x8D
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x2)
	BRSH _0x8E
_0x8D:
	RJMP _0x8C
_0x8E:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0139                                 break;
_0x8C:
	RJMP _0x7F
; 0000 013A                             case 2:	// () /
_0x8A:
	RCALL SUBOPT_0x10
	BRNE _0x8F
; 0000 013B                                 ++buf_set[cursor];
	RCALL SUBOPT_0x3F
; 0000 013C                                 if ((mode == 2)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
	RCALL SUBOPT_0x40
	BRNE _0x91
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x2)
	BRSH _0x92
_0x91:
	RJMP _0x90
_0x92:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 013D                                 if ((mode != 2)&&(buf_set[cursor]>5)) buf_set[cursor]=0;
_0x90:
	RCALL SUBOPT_0x40
	BREQ _0x94
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x6)
	BRSH _0x95
_0x94:
	RJMP _0x93
_0x95:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 013E                                 if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
_0x93:
	RCALL SUBOPT_0x43
	BRNE _0x97
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x2)
	BRSH _0x98
_0x97:
	RJMP _0x96
_0x98:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 013F                                 break;
_0x96:
	RJMP _0x7F
; 0000 0140                             case 3:	// () /
_0x8F:
	RCALL SUBOPT_0x34
	BRNE _0x99
; 0000 0141                                 ++buf_set[cursor];
	RCALL SUBOPT_0x3F
; 0000 0142                                 if (buf_set[cursor]>9) buf_set[cursor]=0;
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0xA)
	BRLO _0x9A
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0143                                 if ((mode == 4)&&(buf_set[cursor]>2)) buf_set[cursor]=0;
_0x9A:
	RCALL SUBOPT_0x43
	BRNE _0x9C
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x3)
	BRSH _0x9D
_0x9C:
	RJMP _0x9B
_0x9D:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0144                                 break;
_0x9B:
	RJMP _0x7F
; 0000 0145                             case 4:	// () / 
_0x99:
	RCALL SUBOPT_0x36
	BRNE _0x9E
; 0000 0146                                 ++buf_set[cursor];
	RCALL SUBOPT_0x3F
; 0000 0147                                 if (((mode == 2)||(mode == 3))&&(buf_set[cursor]>9)) buf_set[cursor]=0;
	RCALL SUBOPT_0x40
	BREQ _0xA0
	RCALL SUBOPT_0x44
	BRNE _0xA2
_0xA0:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0xA)
	BRSH _0xA3
_0xA2:
	RJMP _0x9F
_0xA3:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0148                                 if (mode == 1) buf_set[cursor]=0;
_0x9F:
	RCALL SUBOPT_0x45
	BRNE _0xA4
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0149                                 if (mode == 3){
_0xA4:
	RCALL SUBOPT_0x44
	BRNE _0xA5
; 0000 014A                                     for (i=0; i<2; i++){
	RCALL SUBOPT_0x2A
_0xA7:
	RCALL SUBOPT_0x2B
	CPI  R26,LOW(0x2)
	BRSH _0xA8
; 0000 014B                                         buf_set[i*2]=alarm[buf_set[cursor]][i]/10;   //  
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x3A
	MOVW R22,R30
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x47
; 0000 014C                                         buf_set[i*2+1]=alarm[buf_set[cursor]][i]%10;}
	__ADDW1MN _buf_set,1
	MOVW R22,R30
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x46
	RCALL SUBOPT_0x48
	RCALL SUBOPT_0xE
	RJMP _0xA7
_0xA8:
; 0000 014D                                     buf_set[5]=alarm_on[buf_set[cursor]];
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x3A
	LD   R30,Z
	RCALL SUBOPT_0x15
	LD   R30,Z
	__PUTB1MN _buf_set,5
; 0000 014E                                 }
; 0000 014F                                 if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
_0xA5:
	RCALL SUBOPT_0x43
	BRNE _0xAA
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x2)
	BRSH _0xAB
_0xAA:
	RJMP _0xA9
_0xAB:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0150                                 break;
_0xA9:
	RJMP _0x7F
; 0000 0151                             case 5:	// () / 
_0x9E:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x7F
; 0000 0152                                 ++buf_set[cursor];
	RCALL SUBOPT_0x3F
; 0000 0153                                 if ((mode == 2)&&(buf_set[cursor]>9)) buf_set[cursor]=0;
	RCALL SUBOPT_0x40
	BRNE _0xAE
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0xA)
	BRSH _0xAF
_0xAE:
	RJMP _0xAD
_0xAF:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0154                                 if (mode == 1) buf_set[cursor]=0;
_0xAD:
	RCALL SUBOPT_0x45
	BRNE _0xB0
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0155                                 if ((mode == 3)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
_0xB0:
	RCALL SUBOPT_0x44
	BRNE _0xB2
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x2)
	BRSH _0xB3
_0xB2:
	RJMP _0xB1
_0xB3:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0156                                 if ((mode == 4)&&(buf_set[cursor]>1)) buf_set[cursor]=0;
_0xB1:
	RCALL SUBOPT_0x43
	BRNE _0xB5
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x41
	CPI  R26,LOW(0x2)
	BRSH _0xB6
_0xB5:
	RJMP _0xB4
_0xB6:
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x42
; 0000 0157                                 break;
_0xB4:
; 0000 0158                         }
_0x7F:
; 0000 0159                         for (i=0; i<3; i++)
	RCALL SUBOPT_0x2A
_0xB8:
	RCALL SUBOPT_0x32
	BRSH _0xB9
; 0000 015A                             BUF[i]=buf_set[i*2]*10+buf_set[i*2+1];
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x39
	RCALL SUBOPT_0x3A
	RCALL SUBOPT_0x3B
	__ADDW1MN _buf_set,1
	RCALL SUBOPT_0x3C
	RCALL SUBOPT_0xE
	RJMP _0xB8
_0xB9:
; 0000 015B }
; 0000 015C                     else mode = 5;						//  
	RJMP _0xBA
_0x7C:
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x29
; 0000 015D                	}
_0xBA:
; 0000 015E                 break;
_0x77:
	RJMP _0x51
; 0000 015F 						/*----- SAVE / ALARM OFF -----*/
; 0000 0160     		case 4:
_0x76:
	RCALL SUBOPT_0x36
	BREQ PC+2
	RJMP _0x51
; 0000 0161             	if (BTN_SAVE){                      	//     !!!!!!!!!!!!!!!
	__GETB1MN _KEYS,4
	CPI  R30,0
	BRNE PC+2
	RJMP _0xBC
; 0000 0162             		key_reset;
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	BREQ _0xBD
	RCALL SUBOPT_0x27
	RJMP _0xBE
_0xBD:
	SBI  0x18,1
; 0000 0163                     if ((mode == 0)&&(ring_en)){
_0xBE:
	RCALL SUBOPT_0x28
	CPI  R26,LOW(0x0)
	BRNE _0xC2
	TST  R13
	BRNE _0xC3
_0xC2:
	RJMP _0xC1
_0xC3:
; 0000 0164                     	ring_push_btn = 0; TCCR1A=0x00; BUZZER = 0;//  
	CLR  R12
	RCALL SUBOPT_0x6
	CBI  0x18,1
; 0000 0165                     }
; 0000 0166                     if ((mode==1)||(mode==3)){
_0xC1:
	RCALL SUBOPT_0x45
	BREQ _0xC7
	RCALL SUBOPT_0x44
	BRNE _0xC6
_0xC7:
; 0000 0167                     	if ((BUF[0]>24)||(BUF[1]>59)) {ERROR=1;}
	LDS  R26,_BUF
	CPI  R26,LOW(0x19)
	BRSH _0xCA
	__GETB2MN _BUF,1
	CPI  R26,LOW(0x3C)
	BRLO _0xC9
_0xCA:
	LDI  R30,LOW(1)
	RJMP _0x136
; 0000 0168                         else ERROR=0;
_0xC9:
	LDI  R30,LOW(0)
_0x136:
	STS  _ERROR,R30
; 0000 0169                     }
; 0000 016A 					if (mode==2){
_0xC6:
	RCALL SUBOPT_0x40
	BRNE _0xCD
; 0000 016B                     	if ((BUF[0]>31)||(BUF[1]>12)) {ERROR=1;}
	LDS  R26,_BUF
	CPI  R26,LOW(0x20)
	BRSH _0xCF
	__GETB2MN _BUF,1
	CPI  R26,LOW(0xD)
	BRLO _0xCE
_0xCF:
	LDI  R30,LOW(1)
	RJMP _0x137
; 0000 016C                         else ERROR=0;
_0xCE:
	LDI  R30,LOW(0)
_0x137:
	STS  _ERROR,R30
; 0000 016D                     }
; 0000 016E                     if (!ERROR){
_0xCD:
	LDS  R30,_ERROR
	CPI  R30,0
	BREQ PC+2
	RJMP _0xD2
; 0000 016F                         ind[6] = 0x00;                 //   ->  
	LDI  R30,LOW(0)
	__PUTB1MN _ind,6
; 0000 0170                         ind[7] = 0x00;
	__PUTB1MN _ind,7
; 0000 0171                         ind[8] = 0x00;
	__PUTB1MN _ind,8
; 0000 0172                         ind[9] = 0x00;
	__PUTB1MN _ind,9
; 0000 0173                         if (mode==1) rtc_set_time(BUF[0],BUF[1],BUF[2]);
	RCALL SUBOPT_0x45
	BRNE _0xD3
	RCALL SUBOPT_0x49
	RCALL _rtc_set_time
; 0000 0174                         if (mode==2) rtc_set_date(BUF[0],BUF[1],BUF[2]);
_0xD3:
	RCALL SUBOPT_0x40
	BRNE _0xD4
	RCALL SUBOPT_0x49
	RCALL _rtc_set_date
; 0000 0175 	                    if (mode==3){
_0xD4:
	RCALL SUBOPT_0x44
	BRNE _0xD5
; 0000 0176                         	for (i=0; i<2; i++){
	RCALL SUBOPT_0x2A
_0xD7:
	RCALL SUBOPT_0x2B
	CPI  R26,LOW(0x2)
	BRSH _0xD8
; 0000 0177                             	alarm[buf_set[4]][i]=BUF[i];
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x4B
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x4C
	ST   X,R30
; 0000 0178                             	EEP_ALARM[buf_set[4]][i]=BUF[i];
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x4D
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x4C
	RCALL __EEPROMWRB
; 0000 0179                             }
	RCALL SUBOPT_0xE
	RJMP _0xD7
_0xD8:
; 0000 017A 	                        alarm_on[buf_set[4]]=BUF[2]%10;
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x4E
	RCALL SUBOPT_0x31
; 0000 017B 	                        EEP_alarm_on[buf_set[4]]=BUF[2]%10;
	RCALL SUBOPT_0x4A
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_EEP_alarm_on)
	SBCI R31,HIGH(-_EEP_alarm_on)
	RCALL SUBOPT_0x4E
	RCALL __MODW21
	MOVW R26,R22
	RCALL __EEPROMWRB
; 0000 017C                         }
; 0000 017D 	                    if (mode==4){
_0xD5:
	RCALL SUBOPT_0x43
	BRNE _0xD9
; 0000 017E                         	for (i=0; i<3; i++){
	RCALL SUBOPT_0x2A
_0xDB:
	RCALL SUBOPT_0x32
	BRSH _0xDC
; 0000 017F                             	settings[i]=BUF[i];
	RCALL SUBOPT_0x4F
	SUBI R26,LOW(-_settings)
	SBCI R27,HIGH(-_settings)
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x4C
	ST   X,R30
; 0000 0180                             	EEP_SET[i]=BUF[i];
	RCALL SUBOPT_0x4F
	SUBI R26,LOW(-_EEP_SET)
	SBCI R27,HIGH(-_EEP_SET)
	RCALL SUBOPT_0x38
	RCALL SUBOPT_0x4C
	RCALL __EEPROMWRB
; 0000 0181                             }
	RCALL SUBOPT_0xE
	RJMP _0xDB
_0xDC:
; 0000 0182 							nota = mel[melody_N];
	RCALL SUBOPT_0x1B
; 0000 0183                         }
; 0000 0184                     }
_0xD9:
; 0000 0185                	}
_0xD2:
; 0000 0186                 break;
_0xBC:
; 0000 0187         }
_0x51:
; 0000 0188 	}
	LDS  R30,_key
	SUBI R30,-LOW(1)
	STS  _key,R30
	RJMP _0x4D
_0x4E:
; 0000 0189 //---------------------------------------------------------------------------------
; 0000 018A 
; 0000 018B 							/*----- MODE -----*/
; 0000 018C     switch (mode){
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x13
; 0000 018D         case 0:                                                         //    ( )
	SBIW R30,0
	BREQ PC+2
	RJMP _0xE0
; 0000 018E         	old = TIME[2];                                              //    
	RCALL SUBOPT_0x11
	STS  _old,R30
; 0000 018F 			if (!read_flag){                                            //   
	RCALL SUBOPT_0x50
	BRNE _0xE1
; 0000 0190             	rtc_get_time(&TIME[0], &TIME[1], &TIME[2]);             //  
	LDI  R30,LOW(_TIME)
	LDI  R31,HIGH(_TIME)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _TIME,1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _TIME,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_time
; 0000 0191             }
; 0000 0192             if ((old != TIME[2])){                                      //    
_0xE1:
	RCALL SUBOPT_0x11
	LDS  R26,_old
	CP   R30,R26
	BRNE PC+2
	RJMP _0xE2
; 0000 0193                 setscr(TIME[0], TIME[1], TIME[2], effect);              //  
	LDS  R30,_TIME
	ST   -Y,R30
	RCALL SUBOPT_0x1A
	ST   -Y,R30
	RCALL SUBOPT_0x11
	ST   -Y,R30
	LDS  R26,_settings
	RCALL SUBOPT_0x51
	ST   -Y,R30
	RCALL _setscr
; 0000 0194             	if ((TIME[0]+TIME[1]+TIME[2]) == 0){
	LDS  R26,_TIME
	CLR  R27
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x19
	SBIW R30,0
	BRNE _0xE3
; 0000 0195                 	read_date = 1;         								//    ( 00:00:00)     
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _read_date,R30
	STS  _read_date+1,R31
; 0000 0196                     if ((++depoison) > 9){                              //   10     
	LDS  R26,_depoison
	SUBI R26,-LOW(1)
	STS  _depoison,R26
	CPI  R26,LOW(0xA)
	BRLO _0xE4
; 0000 0197                     	depoison = 0;
	LDI  R30,LOW(0)
	STS  _depoison,R30
; 0000 0198 						mode_reset = 54000;                             // ~1 .
	LDI  R30,LOW(54000)
	LDI  R31,HIGH(54000)
	RCALL SUBOPT_0x52
; 0000 0199                         mode = 6;
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x29
; 0000 019A                     }
; 0000 019B                     EEP_depoison = depoison;                            //
_0xE4:
	LDS  R30,_depoison
	LDI  R26,LOW(_EEP_depoison)
	LDI  R27,HIGH(_EEP_depoison)
	RCALL __EEPROMWRB
; 0000 019C                 }
; 0000 019D                 if (((TIME[1]+TIME[2]) == 0) && (depoison)){
_0xE3:
	RCALL SUBOPT_0x1E
	CLR  R27
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x13
	RCALL SUBOPT_0x17
	SBIW R26,0
	BRNE _0xE6
	LDS  R30,_depoison
	CPI  R30,0
	BRNE _0xE7
_0xE6:
	RJMP _0xE5
_0xE7:
; 0000 019E                 	if (date_show){        								//         
	RCALL SUBOPT_0x8
	RCALL __DIVW21
	SBIW R30,0
	BREQ _0xE8
; 0000 019F     	            	mode_reset = 4500;                              //  ~10 .
	LDI  R30,LOW(4500)
	LDI  R31,HIGH(4500)
	RCALL SUBOPT_0x52
; 0000 01A0 	                    mode = 5;
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x29
; 0000 01A1                     }
; 0000 01A2                     if ((hour_beep==1) && (ring_en==0)){                 //   
_0xE8:
	__GETB2MN _settings,2
	RCALL SUBOPT_0x53
	SBIW R30,1
	BRNE _0xEA
	LDI  R30,LOW(0)
	CP   R30,R13
	BREQ _0xEB
_0xEA:
	RJMP _0xE9
_0xEB:
; 0000 01A3                     	key_reset;
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x26
	BREQ _0xEC
	RCALL SUBOPT_0x27
	RJMP _0xED
_0xEC:
	SBI  0x18,1
; 0000 01A4                     }
_0xED:
; 0000 01A5                 }
_0xE9:
; 0000 01A6             }
_0xE5:
; 0000 01A7             break;
_0xE2:
	RJMP _0xDF
; 0000 01A8         case 6:                                                         //   
_0xE0:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0xF0
; 0000 01A9         	if (!read_flag)
	RCALL SUBOPT_0x50
	BRNE _0xF1
; 0000 01AA                 for (k=0; k<6; k++){
	LDI  R30,LOW(0)
	STS  _k,R30
_0xF3:
	LDS  R26,_k
	CPI  R26,LOW(0x6)
	BRSH _0xF4
; 0000 01AB                     if ((data[k]++)>9)
	RCALL SUBOPT_0x20
	SUBI R26,LOW(-_data)
	SBCI R27,HIGH(-_data)
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	SUBI R30,LOW(1)
	CPI  R30,LOW(0xA)
	BRLO _0xF5
; 0000 01AC                         data[k] = 0;
	LDS  R30,_k
	RCALL SUBOPT_0x54
	RCALL SUBOPT_0xD
; 0000 01AD                 }
_0xF5:
	LDS  R30,_k
	SUBI R30,-LOW(1)
	STS  _k,R30
	RJMP _0xF3
_0xF4:
; 0000 01AE 			break;
_0xF1:
	RJMP _0xDF
; 0000 01AF         case 5:                                                         //   
_0xF0:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0xF7
; 0000 01B0             convert_data(DATE);
	LDI  R30,LOW(_DATE)
	LDI  R31,HIGH(_DATE)
	RJMP _0x138
; 0000 01B1             break;
; 0000 01B2 		default: convert_data(BUF);                                     //       
_0xF7:
	LDI  R30,LOW(_BUF)
	LDI  R31,HIGH(_BUF)
_0x138:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _convert_data
; 0000 01B3 	};
_0xDF:
; 0000 01B4 
; 0000 01B5 //--------------------------   ----------------------------------
; 0000 01B6 
; 0000 01B7     if ((mode>0)&&(mode<5)&&(blink_delay<100)) blink &= ~(1<<shift[cursor]); //    
	RCALL SUBOPT_0x45
	BRLO _0xF9
	RCALL SUBOPT_0x28
	CPI  R26,LOW(0x5)
	BRSH _0xF9
	LDS  R26,_blink_delay
	CPI  R26,LOW(0x64)
	BRLO _0xFA
_0xF9:
	RJMP _0xF8
_0xFA:
	RCALL SUBOPT_0x3E
	SUBI R30,LOW(-_shift)
	SBCI R31,HIGH(-_shift)
	LD   R30,Z
	LDI  R26,LOW(1)
	RCALL __LSLB12
	COM  R30
	LDS  R26,_blink
	AND  R30,R26
	RJMP _0x139
; 0000 01B8     else blink = 0xFE;
_0xF8:
	LDI  R30,LOW(254)
_0x139:
	STS  _blink,R30
; 0000 01B9 //    blink_delay &= 0x00FF;
; 0000 01BA 
; 0000 01BB //---------------------------------------------------------------------------
; 0000 01BC }	//    while{1}
	RJMP _0x18
; 0000 01BD }
_0xFC:
	RJMP _0xFC
;
;// Timer 2 overflow interrupt service routine
;//   2                  115200  / 256 = 450 
;interrupt [TIM2_OVF] void timer2_ovf_isr(void){
; 0000 01C1 interrupt [5] void timer2_ovf_isr(void){
_timer2_ovf_isr:
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 01C2 
; 0000 01C3     static char i;
; 0000 01C4     //anod_1=0; anod_2=0; anod_3=0; anod_4=0; anod_5=0; anod_6=0; anod_7=0;
; 0000 01C5     PORTD &= 0x01;                             	//  
	IN   R30,0x12
	ANDI R30,LOW(0x1)
	OUT  0x12,R30
; 0000 01C6 
; 0000 01C7     read_flag++; read_flag &=0x3F;              //     
	LDI  R26,LOW(_read_flag)
	LDI  R27,HIGH(_read_flag)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	LDS  R30,_read_flag
	LDS  R31,_read_flag+1
	ANDI R30,LOW(0x3F)
	ANDI R31,HIGH(0x3F)
	STS  _read_flag,R30
	STS  _read_flag+1,R31
; 0000 01C8 
; 0000 01C9 	if (iocr<24){                           	//  . < 24
	LDS  R26,_iocr
	CPI  R26,LOW(0x18)
	BRLT PC+2
	RJMP _0xFD
; 0000 01CA         if ((++ms)==16){// ~32 mc               //  . = 16
	LDS  R26,_ms
	SUBI R26,-LOW(1)
	STS  _ms,R26
	CPI  R26,LOW(0x10)
	BRNE _0xFE
; 0000 01CB             ms=0;               	           	// 
	LDI  R30,LOW(0)
	STS  _ms,R30
; 0000 01CC             iocr++;                 		 	//  .
	LDS  R30,_iocr
	SUBI R30,-LOW(1)
	STS  _iocr,R30
; 0000 01CD             for (i=0; i<6; i++){               	//   
	LDI  R30,LOW(0)
	STS  _i_S000000D000,R30
_0x100:
	RCALL SUBOPT_0x55
	CPI  R26,LOW(0x6)
	BRSH _0x101
; 0000 01CE 	            if ((fr[i]==1)||(iocr==0))   	//     . = 0
	LDS  R30,_i_S000000D000
	RCALL SUBOPT_0x56
	LD   R26,Z
	CPI  R26,LOW(0x1)
	BREQ _0x103
	LDS  R26,_iocr
	CPI  R26,LOW(0x0)
	BRNE _0x102
_0x103:
; 0000 01CF     	            bright[i]=psc[iocr];    	//  =   .
	RCALL SUBOPT_0x57
	LDS  R30,_iocr
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_psc*2)
	SBCI R31,HIGH(-_psc*2)
	LPM  R30,Z
	RJMP _0x13A
; 0000 01D0         	    else bright[i]=bright[6]; 		//   = 1
_0x102:
	RCALL SUBOPT_0x57
	__GETB1MN _bright,6
_0x13A:
	ST   X,R30
; 0000 01D1             	if (iocr==13)                 	//  . = 13 (  . psc[13])- 
	LDS  R26,_iocr
	CPI  R26,LOW(0xD)
	BRNE _0x106
; 0000 01D2                 	data[i]=tscr[i]; 			//  
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x20
	SUBI R26,LOW(-_data)
	SBCI R27,HIGH(-_data)
	LDS  R30,_i_S000000D000
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_tscr)
	SBCI R31,HIGH(-_tscr)
	LD   R30,Z
	ST   X,R30
; 0000 01D3             }
_0x106:
	LDS  R30,_i_S000000D000
	SUBI R30,-LOW(1)
	STS  _i_S000000D000,R30
	RJMP _0x100
_0x101:
; 0000 01D4     	}
; 0000 01D5 	}
_0xFE:
; 0000 01D6 
; 0000 01D7 }
_0xFD:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	RETI
;
;// Timer 2 output compare interrupt service routine
;//   
;interrupt [TIM2_COMP] void timer2_comp_isr(void){
; 0000 01DB interrupt [4] void timer2_comp_isr(void){
_timer2_comp_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 01DC 
; 0000 01DD     static char digit = 0;
; 0000 01DE     decoder_out(data[digit]);        					//     
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x59
	ANDI R30,LOW(0x1)
	BRNE _0x107
	CBI  0x15,2
	RJMP _0x108
_0x107:
	SBI  0x15,2
_0x108:
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x59
	ANDI R30,LOW(0x2)
	BRNE _0x109
	CBI  0x15,0
	RJMP _0x10A
_0x109:
	SBI  0x15,0
_0x10A:
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x59
	ANDI R30,LOW(0x4)
	BRNE _0x10B
	CBI  0x18,2
	RJMP _0x10C
_0x10B:
	SBI  0x18,2
_0x10C:
	RCALL SUBOPT_0x58
	RCALL SUBOPT_0x59
	ANDI R30,LOW(0x8)
	BRNE _0x10D
	CBI  0x15,1
	RJMP _0x10E
_0x10D:
	SBI  0x15,1
_0x10E:
; 0000 01DF     ind_temp = ind[digit] & blink;
	LDS  R30,_digit_S000000E000
	RCALL SUBOPT_0xC
	LD   R30,Z
	LDS  R26,_blink
	AND  R30,R26
	STS  _ind_temp,R30
; 0000 01E0 	PORTD = ind_temp;			      					//   
	OUT  0x12,R30
; 0000 01E1 /*
; 0000 01E2     switch (digit){ 									//   
; 0000 01E3         case 0: anod_1=1; break;
; 0000 01E4         case 1: anod_2=1; break;
; 0000 01E5         case 2: anod_3=1; break;
; 0000 01E6         case 3: anod_4=1; break;
; 0000 01E7         case 4: anod_5=1; break;
; 0000 01E8         case 5: anod_6=1; break;
; 0000 01E9         case 6: break; 									// -  
; 0000 01EA     }
; 0000 01EB */
; 0000 01EC     if ((key_delay == 0)){
	LDS  R30,_key_delay
	CPI  R30,0
	BRNE _0x10F
; 0000 01ED     	KEYS[digit] = BUTTON;							//     - 
	LDS  R26,_digit_S000000E000
	RCALL SUBOPT_0x20
	SUBI R26,LOW(-_KEYS)
	SBCI R27,HIGH(-_KEYS)
	LDI  R30,0
	SBIC 0x10,0
	LDI  R30,1
	ST   X,R30
; 0000 01EE 		if (!ring_en) {TCCR1A = 0x00; BUZZER = 0;}
	TST  R13
	BRNE _0x110
	RCALL SUBOPT_0x6
	CBI  0x18,1
; 0000 01EF     }
_0x110:
; 0000 01F0 	else (key_delay--);                      			// 
	RJMP _0x113
_0x10F:
	LDS  R30,_key_delay
	SUBI R30,LOW(1)
	STS  _key_delay,R30
; 0000 01F1     if (key_delay==50){TCCR1A = 0x00; BUZZER=0;}		//          
_0x113:
	LDS  R26,_key_delay
	CPI  R26,LOW(0x32)
	BRNE _0x114
	RCALL SUBOPT_0x6
	CBI  0x18,1
; 0000 01F2 
; 0000 01F3     if ((++digit)>9) digit=0;                           //   
_0x114:
	LDS  R26,_digit_S000000E000
	SUBI R26,-LOW(1)
	STS  _digit_S000000E000,R26
	CPI  R26,LOW(0xA)
	BRLO _0x117
	LDI  R30,LOW(0)
	STS  _digit_S000000E000,R30
; 0000 01F4     OCR2=bright[digit];									//   =  .
_0x117:
	LDS  R30,_digit_S000000E000
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_bright)
	SBCI R31,HIGH(-_bright)
	LD   R30,Z
	OUT  0x23,R30
; 0000 01F5 
; 0000 01F6     blink_delay++;
	LDS  R30,_blink_delay
	SUBI R30,-LOW(1)
	STS  _blink_delay,R30
; 0000 01F7     if (nota_time) nota_time--;
	MOV  R0,R10
	OR   R0,R11
	BREQ _0x118
	MOVW R30,R10
	SBIW R30,1
	MOVW R10,R30
; 0000 01F8 	if (mode_reset == 0) mode = 0;
_0x118:
	LDS  R30,_mode_reset
	LDS  R31,_mode_reset+1
	SBIW R30,0
	BRNE _0x119
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x29
; 0000 01F9     else mode_reset--;
	RJMP _0x11A
_0x119:
	LDI  R26,LOW(_mode_reset)
	LDI  R27,HIGH(_mode_reset)
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 01FA }
_0x11A:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;
;void setscr (char a, char b, char c, char d) 			//   
; 0000 01FD {
_setscr:
; 0000 01FE 	static char i;
; 0000 01FF 	if (d==1){                                          //  .  
;	a -> Y+3
;	b -> Y+2
;	c -> Y+1
;	d -> Y+0
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x11B
; 0000 0200 		tscr[0]=a/10; tscr[1]=a%10; tscr[2]=b/10;
	LDD  R26,Y+3
	RCALL SUBOPT_0x53
	STS  _tscr,R30
	LDD  R26,Y+3
	RCALL SUBOPT_0x51
	__PUTB1MN _tscr,1
	LDD  R26,Y+2
	RCALL SUBOPT_0x53
	__PUTB1MN _tscr,2
; 0000 0201         tscr[3]=b%10; tscr[4]=c/10; tscr[5]=c%10;}		//    
	LDD  R26,Y+2
	RCALL SUBOPT_0x51
	__PUTB1MN _tscr,3
	LDD  R26,Y+1
	RCALL SUBOPT_0x53
	__PUTB1MN _tscr,4
	LDD  R26,Y+1
	RCALL SUBOPT_0x51
	__PUTB1MN _tscr,5
; 0000 0202 	else {
	RJMP _0x11C
_0x11B:
; 0000 0203  		data[0]=a/10; data[1]=a%10; data[2]=b/10;
	LDD  R26,Y+3
	RCALL SUBOPT_0x53
	STS  _data,R30
	LDD  R26,Y+3
	RCALL SUBOPT_0x51
	__PUTB1MN _data,1
	LDD  R26,Y+2
	RCALL SUBOPT_0x53
	__PUTB1MN _data,2
; 0000 0204         data[3]=b%10; data[4]=c/10; data[5]=c%10;} 		//    
	LDD  R26,Y+2
	RCALL SUBOPT_0x51
	__PUTB1MN _data,3
	LDD  R26,Y+1
	RCALL SUBOPT_0x53
	__PUTB1MN _data,4
	LDD  R26,Y+1
	RCALL SUBOPT_0x51
	__PUTB1MN _data,5
_0x11C:
; 0000 0205 	for (i=0; (i<6)&&(d==1); i++){                      //      
	LDI  R30,LOW(0)
	STS  _i_S000000F000,R30
_0x11E:
	LDS  R26,_i_S000000F000
	CPI  R26,LOW(0x6)
	BRSH _0x120
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BREQ _0x121
_0x120:
	RJMP _0x11F
_0x121:
; 0000 0206     	if (tscr[i]!=data[i]) {fr[i]=1;}                //      
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x13
	MOVW R0,R30
	SUBI R30,LOW(-_tscr)
	SBCI R31,HIGH(-_tscr)
	LD   R26,Z
	MOVW R30,R0
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	LD   R30,Z
	CP   R30,R26
	BREQ _0x122
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x56
	LDI  R26,LOW(1)
	RJMP _0x13B
; 0000 0207         else fr[i]=0;
_0x122:
	RCALL SUBOPT_0x5A
	RCALL SUBOPT_0x56
	LDI  R26,LOW(0)
_0x13B:
	STD  Z+0,R26
; 0000 0208   	}
	RCALL SUBOPT_0x5A
	SUBI R30,-LOW(1)
	STS  _i_S000000F000,R30
	RJMP _0x11E
_0x11F:
; 0000 0209  //----------------------------
; 0000 020A 	if (d==1) iocr=-1;                                  //  .   . = -1
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0x124
	LDI  R30,LOW(255)
	RJMP _0x13C
; 0000 020B 	else iocr=25;                                       //  . = 25
_0x124:
	LDI  R30,LOW(25)
_0x13C:
	STS  _iocr,R30
; 0000 020C }
	ADIW R28,4
	RET
;
;
;/*________________        ________________*/
;
;void convert_data (unsigned char x[3]){
; 0000 0211 void convert_data (unsigned char x[3]){
_convert_data:
; 0000 0212 	for (i=0; i<3; i++){
;	x -> Y+0
	RCALL SUBOPT_0x2A
_0x127:
	RCALL SUBOPT_0x32
	BRSH _0x128
; 0000 0213 	 	data[i*2] = /*x[i]>>4;*/x[i]/10;     			// 
	RCALL SUBOPT_0x2C
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x47
; 0000 0214 	 	data[i*2+1] = /*x[i]&0x0F;*/x[i]%10;			// 
	__ADDW1MN _data,1
	RCALL SUBOPT_0x5B
	RCALL SUBOPT_0x48
; 0000 0215     }
	RCALL SUBOPT_0xE
	RJMP _0x127
_0x128:
; 0000 0216 }
_0x2020001:
	ADIW R28,2
	RET
;
;/*_________________       ______________*/
;/*
;void OUT(unsigned char DIGIT)
;{
;    PORTC.2 = DECOD[DIGIT] & 0x01;
;    PORTC.0 = DECOD[DIGIT] & 0x02;           //   . 
;    PORTB.2 = DECOD[DIGIT] & 0x04;
;    PORTC.1 = DECOD[DIGIT] & 0x08;
;}
;*/
;
;/*___________________     EEPROM ____________________*/
;
;void _init(void){
; 0000 0225 void _init(void){
__init:
; 0000 0226 														//    EEPROM
; 0000 0227     for (i=0; i<10; i++){
	RCALL SUBOPT_0x2A
_0x12A:
	RCALL SUBOPT_0xA
	BRSH _0x12B
; 0000 0228         for (j=0; j<2; j++){
	RCALL SUBOPT_0x1D
_0x12D:
	LDS  R26,_j
	CPI  R26,LOW(0x2)
	BRSH _0x12E
; 0000 0229             alarm[i][j] = EEP_ALARM[i][j];
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x4B
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x19
	MOVW R0,R30
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x4D
	RCALL SUBOPT_0x5C
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x5D
; 0000 022A         }
	RCALL SUBOPT_0x1C
	RJMP _0x12D
_0x12E:
; 0000 022B         alarm_on[i] = EEP_alarm_on[i];
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x15
	MOVW R0,R30
	RCALL SUBOPT_0x4F
	SUBI R26,LOW(-_EEP_alarm_on)
	SBCI R27,HIGH(-_EEP_alarm_on)
	RCALL SUBOPT_0x5D
; 0000 022C //        alarm_day[i] = EEP_alarm_day[i];
; 0000 022D     }
	RCALL SUBOPT_0xE
	RJMP _0x12A
_0x12B:
; 0000 022E     for (i=0; i<3; i++){
	RCALL SUBOPT_0x2A
_0x130:
	RCALL SUBOPT_0x32
	BRSH _0x131
; 0000 022F 		settings[i] = EEP_SET[i];
	RCALL SUBOPT_0x38
	SUBI R30,LOW(-_settings)
	SBCI R31,HIGH(-_settings)
	MOVW R0,R30
	RCALL SUBOPT_0x4F
	SUBI R26,LOW(-_EEP_SET)
	SBCI R27,HIGH(-_EEP_SET)
	RCALL SUBOPT_0x5D
; 0000 0230 	}
	RCALL SUBOPT_0xE
	RJMP _0x130
_0x131:
; 0000 0231 	depoison = EEP_depoison;
	LDI  R26,LOW(_EEP_depoison)
	LDI  R27,HIGH(_EEP_depoison)
	RCALL __EEPROMRDB
	STS  _depoison,R30
; 0000 0232 
; 0000 0233 }
	RET
;

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.ESEG
_EEP_ALARM:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
_EEP_alarm_on:
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DB  LOW(0x0),HIGH(0x0),BYTE3(0x0),BYTE4(0x0)
	.DW  0x0
_EEP_SET:
	.DW  0x0
	.DB  0x0
_EEP_depoison:
	.DB  0x0

	.DSEG
_mel:
	.BYTE 0x4
_alarm:
	.BYTE 0x14
_alarm_on:
	.BYTE 0xA
_repeat:
	.BYTE 0x1
_i:
	.BYTE 0x1
_k:
	.BYTE 0x1
_j:
	.BYTE 0x1
_depoison:
	.BYTE 0x1
_blink_delay:
	.BYTE 0x1
_blink:
	.BYTE 0x1
_KEYS:
	.BYTE 0xA
_key:
	.BYTE 0x1
_key_delay:
	.BYTE 0x1
_cursor:
	.BYTE 0x1
_shift:
	.BYTE 0x7
_mode:
	.BYTE 0x1
_mode_reset:
	.BYTE 0x2
_read_flag:
	.BYTE 0x2
_read_date:
	.BYTE 0x2
_ERROR:
	.BYTE 0x1
_ind:
	.BYTE 0xA
_ind_temp:
	.BYTE 0x1
_data:
	.BYTE 0xA
_TIME:
	.BYTE 0x3
_DATE:
	.BYTE 0x3
_BUF:
	.BYTE 0x3
_buf_set:
	.BYTE 0x7
_old:
	.BYTE 0x1
_settings:
	.BYTE 0x3
_iocr:
	.BYTE 0x1
_ms:
	.BYTE 0x1
_fr:
	.BYTE 0x6
_tscr:
	.BYTE 0x6
_bright:
	.BYTE 0xA
_i_S000000D000:
	.BYTE 0x1
_digit_S000000E000:
	.BYTE 0x1
_i_S000000F000:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x0:
	RCALL _twi_start
	LDI  R30,LOW(208)
	ST   -Y,R30
	RJMP _twi_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1:
	ST   -Y,R30
	RJMP _twi_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	ST   -Y,R30
	RCALL _bin2bcd
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _twi_read
	ST   -Y,R30
	RJMP _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LD   R26,Y
	LDD  R27,Y+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x5:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _twi_read
	ST   -Y,R30
	RJMP _bcd2bin

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(0)
	OUT  0x2F,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDS  R30,_mode
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	__GETB2MN _settings,1
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(6)
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	LDS  R26,_i
	CPI  R26,LOW(0xA)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 43 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0xB:
	LDS  R30,_i
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0xC:
	LDI  R31,0
	SUBI R30,LOW(-_ind)
	SBCI R31,HIGH(-_ind)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 24 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0xD:
	LDI  R26,LOW(0)
	STD  Z+0,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:40 WORDS
SUBOPT_0xE:
	RCALL SUBOPT_0xB
	SUBI R30,-LOW(1)
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xF:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x10:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x11:
	__GETB1MN _TIME,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(_DATE)
	LDI  R31,HIGH(_DATE)
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _DATE,1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1MN _DATE,2
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_get_date
	LDI  R30,LOW(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 113 TIMES, CODE SIZE REDUCTION:222 WORDS
SUBOPT_0x13:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x14:
	LDS  R30,_j
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x15:
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_alarm_on)
	SBCI R31,HIGH(-_alarm_on)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x16:
	RCALL SUBOPT_0x14
	LDI  R26,LOW(_alarm)
	LDI  R27,HIGH(_alarm)
	RCALL SUBOPT_0x13
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x17:
	ADD  R26,R30
	ADC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	LD   R26,X
	LDS  R30,_TIME
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x19:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	__GETB1MN _TIME,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:26 WORDS
SUBOPT_0x1B:
	__GETB2MN _settings,2
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	LDI  R26,LOW(_mel)
	LDI  R27,HIGH(_mel)
	LSL  R30
	ROL  R31
	RCALL SUBOPT_0x17
	LD   R4,X+
	LD   R5,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	RCALL SUBOPT_0x14
	SUBI R30,-LOW(1)
	STS  _j,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1D:
	LDI  R30,LOW(0)
	STS  _j,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1E:
	__GETB2MN _TIME,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1F:
	LDD  R30,Z+1
	RCALL SUBOPT_0x13
	ADIW R30,5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 41 TIMES, CODE SIZE REDUCTION:78 WORDS
SUBOPT_0x20:
	LDI  R27,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x21:
	RCALL SUBOPT_0x13
	LSL  R30
	ROL  R31
	RCALL SUBOPT_0x19
	RCALL __GETW1PF
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x22:
	OUT  0x2A+1,R31
	OUT  0x2A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x23:
	LDS  R26,_settings
	RCALL SUBOPT_0x20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x24:
	LDS  R30,_key
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x25:
	SUBI R30,LOW(-_KEYS)
	SBCI R31,HIGH(-_KEYS)
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:34 WORDS
SUBOPT_0x26:
	LDI  R30,LOW(150)
	STS  _key_delay,R30
	LDI  R30,LOW(4500)
	LDI  R31,HIGH(4500)
	STS  _mode_reset,R30
	STS  _mode_reset+1,R31
	RJMP SUBOPT_0x23

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x27:
	LDI  R30,LOW(64)
	OUT  0x2F,R30
	LDI  R30,LOW(2095)
	LDI  R31,HIGH(2095)
	RJMP SUBOPT_0x22

;OPTIMIZER ADDED SUBROUTINE, CALLED 28 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x28:
	LDS  R26,_mode
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x29:
	STS  _mode,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(0)
	STS  _i,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 31 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x2B:
	LDS  R26,_i
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:43 WORDS
SUBOPT_0x2C:
	RCALL SUBOPT_0x2B
	LDI  R30,LOW(2)
	MUL  R30,R26
	MOVW R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x2D:
	SUBI R30,LOW(-_buf_set)
	SBCI R31,HIGH(-_buf_set)
	MOVW R22,R30
	RCALL SUBOPT_0xB
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2E:
	SUBI R30,LOW(-_TIME)
	SBCI R31,HIGH(-_TIME)
	LD   R26,Z
	RCALL SUBOPT_0x20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x2F:
	RCALL __DIVW21
	MOVW R26,R22
	ST   X,R30
	RJMP SUBOPT_0x2C

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x30:
	__ADDW1MN _buf_set,1
	MOVW R22,R30
	RCALL SUBOPT_0xB
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x31:
	RCALL __MODW21
	MOVW R26,R22
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x32:
	RCALL SUBOPT_0x2B
	CPI  R26,LOW(0x3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x33:
	SUBI R30,LOW(-_DATE)
	SBCI R31,HIGH(-_DATE)
	LD   R26,Z
	RCALL SUBOPT_0x20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x34:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	SUBI R30,LOW(-_alarm)
	SBCI R31,HIGH(-_alarm)
	LD   R26,Z
	RCALL SUBOPT_0x20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x36:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x37:
	SUBI R30,LOW(-_settings)
	SBCI R31,HIGH(-_settings)
	LD   R26,Z
	RCALL SUBOPT_0x20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x38:
	RCALL SUBOPT_0xB
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x39:
	SUBI R30,LOW(-_BUF)
	SBCI R31,HIGH(-_BUF)
	__PUTW1R 23,24
	RJMP SUBOPT_0x2C

;OPTIMIZER ADDED SUBROUTINE, CALLED 38 TIMES, CODE SIZE REDUCTION:35 WORDS
SUBOPT_0x3A:
	SUBI R30,LOW(-_buf_set)
	SBCI R31,HIGH(-_buf_set)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3B:
	LD   R30,Z
	LDI  R26,LOW(10)
	MULS R30,R26
	MOV  R22,R0
	RJMP SUBOPT_0x2C

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3C:
	LD   R30,Z
	ADD  R30,R22
	__GETW2R 23,24
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3D:
	LDS  R26,_cursor
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 37 TIMES, CODE SIZE REDUCTION:70 WORDS
SUBOPT_0x3E:
	LDS  R30,_cursor
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:28 WORDS
SUBOPT_0x3F:
	RCALL SUBOPT_0x3D
	RCALL SUBOPT_0x20
	SUBI R26,LOW(-_buf_set)
	SBCI R27,HIGH(-_buf_set)
	LD   R30,X
	SUBI R30,-LOW(1)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x40:
	RCALL SUBOPT_0x28
	CPI  R26,LOW(0x2)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x41:
	RCALL SUBOPT_0x3A
	LD   R26,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 17 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0x42:
	RCALL SUBOPT_0x3A
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x43:
	RCALL SUBOPT_0x28
	CPI  R26,LOW(0x4)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x44:
	RCALL SUBOPT_0x28
	CPI  R26,LOW(0x3)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x45:
	RCALL SUBOPT_0x28
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x46:
	RCALL SUBOPT_0x3A
	LD   R30,Z
	LDI  R26,LOW(_alarm)
	LDI  R27,HIGH(_alarm)
	RCALL SUBOPT_0x13
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	RJMP SUBOPT_0x38

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x47:
	RCALL SUBOPT_0x17
	LD   R30,X
	RCALL SUBOPT_0x13
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP SUBOPT_0x2F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x48:
	RCALL SUBOPT_0x17
	LD   R26,X
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP SUBOPT_0x31

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x49:
	LDS  R30,_BUF
	ST   -Y,R30
	__GETB1MN _BUF,1
	ST   -Y,R30
	__GETB1MN _BUF,2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4A:
	__GETB1MN _buf_set,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4B:
	LDI  R26,LOW(_alarm)
	LDI  R27,HIGH(_alarm)
	RCALL SUBOPT_0x13
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4C:
	SUBI R30,LOW(-_BUF)
	SBCI R31,HIGH(-_BUF)
	LD   R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4D:
	LDI  R26,LOW(_EEP_ALARM)
	LDI  R27,HIGH(_EEP_ALARM)
	RCALL SUBOPT_0x13
	LSL  R30
	ROL  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x4E:
	MOVW R22,R30
	__GETB2MN _BUF,2
	RCALL SUBOPT_0x20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4F:
	RCALL SUBOPT_0x2B
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x50:
	LDS  R30,_read_flag
	LDS  R31,_read_flag+1
	SBIW R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x51:
	CLR  R27
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x52:
	STS  _mode_reset,R30
	STS  _mode_reset+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x53:
	RCALL SUBOPT_0x20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x54:
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_data)
	SBCI R31,HIGH(-_data)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x55:
	LDS  R26,_i_S000000D000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x56:
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_fr)
	SBCI R31,HIGH(-_fr)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x57:
	RCALL SUBOPT_0x55
	RCALL SUBOPT_0x20
	SUBI R26,LOW(-_bright)
	SBCI R27,HIGH(-_bright)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x58:
	LDS  R30,_digit_S000000E000
	RJMP SUBOPT_0x54

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x59:
	LD   R30,Z
	RCALL SUBOPT_0x13
	SUBI R30,LOW(-_DECOD*2)
	SBCI R31,HIGH(-_DECOD*2)
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5A:
	LDS  R30,_i_S000000F000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5B:
	MOVW R22,R30
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0x4
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x5C:
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x14
	RJMP SUBOPT_0x13

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5D:
	RCALL __EEPROMRDB
	MOVW R26,R0
	ST   X,R30
	RET


	.CSEG
__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

;END OF CODE MARKER
__END_OF_CODE:
